package org.apache.jsp;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import com.sun.ts.tests.jsp.common.util.JspTestUtil;
import java.io.IOException;

public final class ErrorDataTest_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {


    private static final ErrorData getErrorDataInstance() {
        return new ErrorData(new RuntimeException("runtime"), 501, "/uri", "TestServlet");
    }


    public void errorDataConstructorTest(HttpServletRequest req,
                                         HttpServletResponse res,
                                         JspWriter out)
    throws ServletException, IOException {
        ErrorData data = getErrorDataInstance();
        if (data != null) {
            out.print("Test PASSED");
        } else {
            out.print("Test FAILED.  Constructor of new ErrorData object failed.");
        }
    }


    public void errorDataGetThrowableTest(HttpServletRequest req,
                                          HttpServletResponse res,
                                          JspWriter out)
    throws ServletException, IOException {
        ErrorData data = getErrorDataInstance();
        Throwable t = null;

        if (data != null) {
            t = data.getThrowable();
        } else {
            out.println("Test FAILED.  ErrorData instance was null.");
            return;
        }

        if (t != null) {
            String message = t.getMessage();
            if (message != null && message.equals("runtime")) {
                out.println("Test PASSED");
            } else {
                out.println("Test FAILED.  Expected throwable message of 'runtime'");
                out.println("Message returned: " + message);
            }
        } else {
            out.println("Test FAILED.  ErrorData.getThrowable() returned null.");
        }
    }


    public void errorDataGetStatusCodeTest(HttpServletRequest req,
                                           HttpServletResponse res,
                                           JspWriter out)
    throws ServletException, IOException {
        ErrorData data = getErrorDataInstance();
        int code = 0;

        if (data != null) {
            code = data.getStatusCode();
        } else {
            out.println("Test FAILED.  ErrorData instance was null.");
            return;
        }

        if (code == 501) {
            out.println("Test PASSED");
        } else {
            out.println("Test FAILED.  Expected a status code of 501.");
            out.println("Status code recieved: " + code);
        }
    }


    public void errorDataGetRequestURITest(HttpServletRequest req,
                                           HttpServletResponse res,
                                           JspWriter out)
    throws ServletException, IOException {
        ErrorData data = getErrorDataInstance();
        String uri = null;

        if (data != null) {
            uri = data.getRequestURI();
        } else {
            out.println("Test FAILED.  ErrorData instance was null.");
            return;
        }

        if (uri != null) {
            if (uri.equals("/uri")) {
                out.println("Test PASSED");
            } else {
                out.println("Test FAILED.  Expected a value of '/uri'.");
                out.println("Received: " + uri);
            }
        } else {
            out.println("Test FAILED.  ErrorData.getRequestURI() returned null.");
        }
    }


    public void errorDataGetServletNameTest(HttpServletRequest req,
                                            HttpServletResponse res,
                                            JspWriter out)
    throws ServletException, IOException {
        ErrorData data = getErrorDataInstance();
        String name = null;

        if (data != null) {
            name = data.getServletName();
        } else {
            out.println("Test FAILED.  ErrorData instance was null.");
            return;
        }

        if (name != null) {
            if (name.equals("TestServlet")) {
                out.println("Test PASSED");
            } else {
                out.println("Test FAILED.  Expected a value of 'TestServlet'");
                out.println("Received: " + name);
            }
        } else {
            out.println("Test FAILED. ErrorData.getServletName() returned null.");
        }
    }

  private static final JspFactory _jspxFactory = JspFactory.getDefaultFactory();

  private static java.util.List<String> _jspx_dependants;

  private org.glassfish.jsp.api.ResourceInjector _jspx_resourceInjector;

  public java.util.List<String> getDependants() {
    return _jspx_dependants;
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;

    try {
      response.setContentType("text/plain");
      response.setHeader("X-Powered-By", "JSP/2.3");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;
      _jspx_resourceInjector = (org.glassfish.jsp.api.ResourceInjector) application.getAttribute("com.sun.appserv.jsp.resource.injector");

      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write("\n");
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
      out.write('\n');
 JspTestUtil.invokeTest(this, request, response, out); 
      out.write('\n');
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          out.clearBuffer();
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
        else throw new ServletException(t);
      }
    } finally {
      _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
